import 'type_adapter.dart';
import 'type_registry.dart';

/// The [BinaryWriter] is used to encode data to the binary format.
abstract class BinaryWriter {
  const BinaryWriter(this.registry);

  final TypeRegistry registry;

  /// Write a single byte.
  void writeBytes(List<int> bytes);

  /// Write using the given adapter.
  void write<T>(TypeAdapter<T> adapter, T value) => adapter.write(this, value);
}
